import {BehaviorSubject} from 'rxjs/BehaviorSubject';

export class Computesite {
  url: string;  // The URL runs a web service to help construct sbatch commands
                // Infact the URL should return the entire interface for
                // submit stat and cancel
  name: string; // Human readable name
  host: string; // Login host
  dtn: string;
  dtnport: string;
  lscmd: string;
  cafingerprint: string;  // Certificates contain a CA fingerprint. We use this
                          // to figure out which compute site a certificate is valid
                          // for
  appCatalog: BehaviorSubject<Strudelapp[]>;
  appCatalogUri: string;
  appCatalogCmd: string;
  internalfirewall: boolean; // Does a firewall exist within the site necessitating an extra level of ssh tunnel
  cancelcmd: string;
  statcmd: string;
  userhealth: string;
  cacheturis: string[];
}

export class Strudelapp {
  url: string; // A url used to retrieve extra config options. May be null
  name: string; // Human readable name
  startscript: string; // batch script ... should NOT include resource directives
                       // resource directives like #SBATCH belong in the batchinterface
  paramscmd: string;  // command to return extra data such as passwords and tokens
                      // values returned here can be used in the client strings
  client: {cmd: string[], redir: string};
  localbind: boolean; // does the application bind to a port on the localhost
                      // interface or on all interfaces. This behaviour determins
                      /// how we create tunnels
}

export class Health {
  stat: string;
  msg: string;
  type: string;
  data: any;
  title: string;
}
